#include <iostream>
#include <stdlib.h>
using namespace std;

//DEFINITON DES CONSTANTES
const int N = 3; //Dimension des vecteurs Elearn
const int nb_cas = 8;

//*****************************************************************************
//ALGORITHME DE CLASSEMENT
int perceptron(float P[N-1], float L[nb_cas][N], int j, float b)
{
if (P[0]*L[j][0]+P[1]*L[j][1]+b > 0)
   {return 1;}
else
   {return -1;}       
}

//*****************************************************************************
//PROGRAMME PRINCIPAL
int main()
{
    
//Dclaration des variables
float Poids [N-1];
float alpha = 2;
float b;
int t = 0;
int i;
int j;
int k;
int y;

//Dfinition de l'ensemble d'apprentissage
//g = 1 pour le Nord
//g = -1 pour le sud
float Learn [nb_cas][N] = { {0.15 , 0.4 , -1} , {0.35 , 0.4 , -1} , {0.35 , 0.2 , -1} , {0.6 , 0.2 , -1} , {0.6 , 0.95 , 1} , {0.65 , 0.8 , 1} , {0.8 , 0.8 ,1} , {0.9 , 0.9 , 1} };

//Phase d'apprentissage

//Dfinition d'alpha
cout<<"Phase d'apprentissage."<<endl;
cout<<"Entrez unz valeur de alpha entre 0 et 1."<<endl;
do {cin>>alpha;} while ((alpha<=0)||(alpha>1));

//Dfinition de t
cout<<"Entrez unz valeur de t, le nombre d'iterations d'apprentissage."<<endl;
do {cin>>t;} while (t<=0);

//Initialisation
b = 0;
for (i=0;i<N-1;i++)
   {Poids[i] = 0;}

//Boucle d'apprentissage
for (k=1;k<=t;k++)
   {for (j=1;j<=8;j++)
       {y = perceptron(Poids, Learn, j, b);
        if (y != Learn[j][2])
           {for (i=0;i<N-1;i++)
                {Poids[i] = Poids[i] + Learn[j][i]*alpha*Learn[j][2];}
            b = b + alpha*Learn[j][2];}
        }
    }

//Prsentation des rsultats
cout<<endl<<"Finalement la droite separatrice est :"<<endl;
cout<<Poids[0]<<" * x1 + "<<Poids[1]<<" * x2 + "<<b<<" = 0"<<endl;
cout<<endl<<"soit : Y = "<<Poids[0]/Poids[1]<<" X + "<<b/Poids[1]<<endl;




system ("pause");
return (0);
}
