#include<iostream>
#include<stdlib.h>


using namespace std;

#define FORCE 20000
#define NB_C1 4
#define NB_C2 4

int main(void){
    cout<<"Perceptron"<<endl;
    
    //ensembles d'apprentissage
    //    float E1[NB_C1][2]={{.3,.4},{.4,.4},{.4,.3},{.4,.2}};
    //    float E2[NB_C2][2]={{.1,.1},{.1,.2},{.2,.2},{.2,.4}};
    float E1[NB_C1][2]={{.1,.4},{.1,.2},{.3,.3},{.2,.3}};
    float E2[NB_C2][2]={{.4,.6},{.5,.4},{.3,.5},{.5,.5}};    
    //initialisation des poids du neurone
    float poids[2]={0.,0.};
    
    //increment d'apprentissage
    float inc=0.2;
    float biais=0.;
    
    //autres variables
    int i,j;
    int saisie,iter=FORCE;
    float x,y; // coordonnes d'un point  tester aprs apprentissage
    float reponse;
    char affiche='O';
    
    //boucle d'apprentissage 
  while(true){
    do
        {
        cout<<"Entrez un pas d'apprentissage (ou 0 pour sortir)"<<endl;
        cin>>inc;
        }
      while (inc<0.0 || inc>1.0);
    if (inc==0.0) break;
    do
        {
        cout<<"Entrez le nombre d'iterations"<<endl;
        cin>>iter;
        }
      while (iter<0 || iter>2000000);
    cout<<"Afficher apres chaque iteration ? (O pour oui)"<<endl;
    cin>>affiche;
    cout<<"Pas d'apprentissage : "<<inc<<" iterations :"<<iter<<endl;
    // remise  0
    poids[0]=0.0;
    poids[1]=0.0;
    biais=0.0;
    // apprentissage sur chantillon
    for(i=0;i<iter;i++){
        //verification du premier ensemble E1
        for(j=0;j<NB_C1;j++){
            reponse=E1[j][0]*poids[0]+E1[j][1]*poids[1]+biais;
            //si reponse<0 alors mal class?
            if(reponse<=0){
                poids[0]=poids[0]+E1[j][0]*inc;
                poids[1]=poids[1]+E1[j][1]*inc;
                biais+=inc;
            }
        }
        //verification du second ensemble E2
        for(j=0;j<NB_C2;j++){
            reponse=E2[j][0]*poids[0]+E2[j][1]*poids[1]+biais;
            //si reponse>0 alors mal class?
            if(reponse>0){
                poids[0]=poids[0]-E2[j][0]*inc;
                poids[1]=poids[1]-E2[j][1]*inc;
                biais-=inc;
            }
        }
        if (affiche=='O')
           {
            cout<<"  p["<<poids[0]<<","<<poids[1]<<","<<biais<<"]"<<endl;
            cout<<"  droite separatrice : ("<<poids[0]<<")*x + ("<<poids[1]<<")*y + ("<<biais<<") = 0"<<endl;
            cout<<"  Passe par (0, "<<(-biais/poids[1])<<"), et par (1, "<<(-biais-poids[1])/poids[0]<<")"<<endl;
            system("pause");
            }
    }
    cout<<"  p["<<poids[0]<<","<<poids[1]<<","<<biais<<"]"<<endl;
    cout<<"  droite separatrice : ("<<poids[0]<<")*x + ("<<poids[1]<<")*y + ("<<biais<<") = 0"<<endl;
    cout<<"  Passe par (0, "<<(-biais/poids[1])<<"), et par (1, "<<(-biais-poids[1])/poids[0]<<")"<<endl;
    // interrogation pour de nouveaux points
    x=1.0;
    while (x!=0.0 && y!=0.0)
        {
        cout<<"  Entrez les coordonnees d'un point a verifier (ou 0 0 pour une autre simulation) :"<<endl<<"  ";
        cin>>x>>y;
        reponse=x*poids[0]+y*poids[1]+biais;
        cout<<"  Vous avez demande x="<<x<<" et y="<<y<<" reponse="<<reponse<<endl;
        if (reponse>0.0) cout<<"  Sud-ouest !"<<endl; else cout<<"  Nord-est !"<<endl;
        }
        
  }
  system("PAUSE");
  return 1;   
}
