#include<stdlib.h>
#include<iostream.h>
#include<math.h>

#define FORCE 10000
#define NB_C1 4
#define NB_C2 4

int main(void){
    cout<<"Perceptron"<<endl;
    
    //ensembles d'apprentissage
    float E1[NB_C1][2]={{.5,.6},{.6,.4},{.4,.1},{.6,.5}};
    float E2[NB_C2][2]={{.2,.4},{.2,.2},{.4,.4},{.3,.3}};

    //initialisation des poids du neurone
    float poids[2]={0.,0.};
    
    //increment d'apprentissage
    float inc=.1;
    float biais=0.;
    
    //autres variables
    int i,j;
    
    //boucle d'apprentissage 
    for(i=0;i<FORCE;i++){    	
    	
        //verification du premier ensemble E1
        for(j=0;j<NB_C1;j++){
            float reponse=E1[j][0]*poids[0]+E1[j][1]*poids[1]+biais;
            //si reponse<0 alors mal classé
            if(reponse<=0){
                poids[0]=poids[0]+E1[j][0]*inc;
                poids[1]=poids[1]+E1[j][1]*inc;
                biais+=inc;
            }
        }
        //verification du second ensemble E2
        for(j=0;j<NB_C2;j++){
            float reponse=E2[j][0]*poids[0]+E2[j][1]*poids[1]+biais;
            //si reponse>0 alors mal classé
            if(reponse>0){
                poids[0]=poids[0]-E2[j][0]*inc;
                poids[1]=poids[1]-E2[j][1]*inc;
                biais-=inc;
            }
        }
    }
    cout<<"p["<<poids[0]<<","<<poids[1]<<","<<biais<<"]"<<endl;
    cout<<"  droite separatrice : ("<<poids[0]<<")*x + ("<<poids[1]<<")*y + ("<<biais<<") = 0"<<endl;
    cout<<"  Passe par (0, "<<(-biais/poids[1])<<"), et par (1, "<<(-biais-poids[1])/poids[0]<<")"<<endl;
    return 1;   
}
